{   
   Simple Video Capture and Record
}

CON
  ' Set up the processor clock in the standard way for 80MHz 
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000 + 0000

  HORIZONTAL_PIXELS =  80
  VERTICAL_PIXELS =  96
  VIDCAP_PIXELS = 64
  
  _irrpin      = 7      ' ir receiver module on this pin
  _device      = $DF20  ' accept fortec device code
  _dlyrpt      = 6      ' delay before accepting code as repeat

   spiDO     = 0
   spiClk    = 1
   spiDI     = 2
   spiCS     = 3
      
VAR

    byte  video[72*192]
    byte  displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
 
                               
  long  temp,temp2,index,line_no,video_l,video_r,display_l,display_r   'temp offset for byte statement below

  long  i, j, k, l, m     'misc working vars
  long  ir_code,shift,audio
  long ioControl[2],block   
  
OBJ
     tv    : "potatohead--hi-color-80x96"   'the TV driver
  capture  : "video_capture"
  process  : "video_process_80x96"
  sound    : "ADC_sound"     
       ir  : "ir_cog_fortec"
     fsrw  : "fsrwFEMTO" 
'   uart    : "FullDuplexSerial"
  
PUB start '|  c, o, d, p 

    
   'fill bitmap with valid pixels, before triggering display there is no Color Lookup
   'Table in the TV driver just yet.
   
    repeat index from 0 to (HORIZONTAL_PIXELS * VERTICAL_PIXELS) 
      byte [@displayb] [index] := 3 '@@clut[1]  'There is a CLUT in this program though
           
'    tv.start(@displayb)  ' Cog #1 start the tv cog & pass it the address of the bitmap 

 
    video_l := @displayb[0]' + 323 '@video
    video_r := @video[0]
   
    capture.frames(video_r)  ' Cog #2
    process.frames(video_r,video_l) ' Cog #3
'    sound.SigmaDelta(@audio)        ' Cog #4
   
'    ir.init(_irrpin,_device,_dlyrpt,true) ' Cog #5
    fsrw.start(@ioControl) 
    fsrw.mount(spiDO,spiClk,spiDI,spiCS)

    i:=fsrw.popen(string("video3.pop"), "w")
    
    repeat 30
      
      ir_code := ir_convert(ir.fifo_get)   ' get last infra red receiver key press
         
      if  ir_code ==  ">"            ' right arrow key
           process.frames(video_r,video_l)
           shift++
                                   ' left arrow key
      if  ir_code ==  "<"
          process.stop
          shift--
          
      shift &= 7                 ' make sure shift amount does not get out of bounds
      if shift > 5
        shift := 5
           
      repeat line_no from 0 to 96
'        i:=fsrw.pwrite(@audio,4)
        i:=fsrw.pwrite(@video+line_no*2*72, 72)
          
'      if ir_code == $0D
'        grab1.stop
'        Screen_Grab
'        grab1.frames(@displayb+10)

    fsrw.pclose    
      
pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  c := c & %0111 'uncomment for monochrome display only

  'keep things sane
  x := x // HORIZONTAL_PIXELS
  y := y // VERTICAL_PIXELS
    
  displayb[y*HORIZONTAL_PIXELS+x] := @@clut[c & %01111111]   '128 color CLUT

pub get_display_byte(x,y)

  'keep things sane
  x := x // HORIZONTAL_PIXELS
  y := y // VERTICAL_PIXELS
    
  return displayb[y*HORIZONTAL_PIXELS+x] 
  
PUB ir_convert(ir_key)
' translate ir_remote to internal form )ascii?
 return lookup(ir_key+1: "1","2","3","4","5","6","7","8","9","0", $5E, $7E, ">", "<" ,0,0,"*",0,0,0,"#",0,0,0,0,$0D )
        

DAT

'Two Color tables here.  This commented one has the lowest intensity of each
'possible hue mapped to the low intensity color instead of the lowest intensity
'color.  Some televisions do not play well with these when they occupy large areas
'of the screen.  I've not had any trouble with mixed colors that incorporate these
'however.  YMMV.

'color lookup table, upper 4 bits hue, lower 4 intensity and saturation
'mixed together.  I've got the high saturation colors mapped to their
'closest hue.  They are the last two entries.

'I am including these as they make life easy with the standard propeller colors
'
'Ideally, a high color display will have these mappings crafted for 8 bit color
'such that the graphics generate code can then just ask for a color, instead of
'doing the tedious dot plotting I'm doing here for demonstration / proof of technique


clut
clut0   byte  byte  $02, $03, $04, $05, $06, $06, $06, $06  
clut1   byte  byte  $0a, $0b, $0c, $0d, $0e, $0f, $10, $11
clut2   byte  byte  $2a, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $3a, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $4a, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $5a, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $6a, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $7a, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $8a, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $9a, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $aa, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $ba, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $ca, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $da, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $ea, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $fa, $fa, $fb, $fc, $fd, $fe, $78, $8f